msgpack::type Namespace Reference

## Namespaces

| detail

## Classes

struct | array_ref
struct | array_ref< T[N]>
class | assoc_vector
struct | const_tuple_element
struct | define_array
struct | define_array<>
struct | define_array_imp
struct | define_array_imp< Tuple, 1 >
struct | define_map
struct | define_map<>
struct | define_map_imp
struct | define_map_imp< Tuple, 0 >
class | ext
class | ext_ref
struct | fix_int
struct | nil_t
struct | raw_ref
struct | size_equal_only
class | tuple
struct | tuple<>
struct | tuple_element
struct | tuple_type
struct | tuple_type< const T & >
struct | tuple_type< T & >
struct | v4raw_ref

## Typedefs

typedef fix_int< uint8_t > | fix_uint8
typedef fix_int< uint16_t > | fix_uint16
typedef fix_int< uint32_t > | fix_uint32
typedef fix_int< uint64_t > | fix_uint64
typedef fix_int< int8_t > | fix_int8
typedef fix_int< int16_t > | fix_int16
typedef fix_int< int32_t > | fix_int32
typedef fix_int< int64_t > | fix_int64
typedef nil_t | nil

## Enumerations

enum

object_type {
NIL = MSGPACK_OBJECT_NIL, BOOLEAN = MSGPACK_OBJECT_BOOLEAN, POSITIVE_INTEGER = MSGPACK_OBJECT_POSITIVE_INTEGER, NEGATIVE_INTEGER = MSGPACK_OBJECT_NEGATIVE_INTEGER,
FLOAT32 = MSGPACK_OBJECT_FLOAT32, FLOAT64 = MSGPACK_OBJECT_FLOAT64, FLOAT = MSGPACK_OBJECT_FLOAT, STR = MSGPACK_OBJECT_STR,
BIN = MSGPACK_OBJECT_BIN, ARRAY = MSGPACK_OBJECT_ARRAY, MAP = MSGPACK_OBJECT_MAP, EXT = MSGPACK_OBJECT_EXT
}

## Functions

template<typename T >
msgpack::enable_if< !msgpack::is_array< T const >::value, array_ref< T const >>::type | make_array_ref (const T &t)
template<typename T >
msgpack::enable_if< !msgpack::is_array< T >::value, array_ref< T >>::type | make_array_ref (T &t)
template<typename T , std::size_t N>
array_ref< const T[N]> | make_array_ref (const T(&t)[N])
template<typename T , std::size_t N>
array_ref< T[N]> | make_array_ref (T(&t)[N])
define_array | make_define_array ()
define_map | make_define_map ()
tuple | make_tuple ()
template<typename T >
std::enable_if< has_as< T >::value >::type | convert_helper (msgpack::object const &o, T &t)
template<typename T >
std::enable_if< !has_as< T >::value >::type | convert_helper (msgpack::object const &o, T &t)
template<typename... Args>
define_array< Args... > | make_define_array (Args &... args)
template<typename... Args>
define_map< Args... > | make_define_map (Args &... args)
template<class... Args>
tuple< Args... > | make_tuple (Args &&... args)
template<class... Args>
tuple< Args &&... > | forward_as_tuple (Args &&... args) noexcept
template<class... Tuples>
auto | tuple_cat (Tuples &&... args) -> decltype(std::tuple_cat(std::forward< typename std::remove_reference< Tuples >::type::base >(args)...))
template<class... Args>
tuple< Args &... > | tie (Args &... args)
bool | operator< (nil_t const &lhs, nil_t const &rhs)
bool | operator== (nil_t const &lhs, nil_t const &rhs)
template<typename T >
std::size_t | size (T const &t)
template<typename T , std::size_t N>
std::size_t | size (const T(&)[N])
template<typename... T>
std::size_t | size (std::tuple< T... > const &)
template<typename T >
size_equal_only< T > | make_size_equal_only (T &t)
template<typename T >
bool | operator< (size_equal_only< T > const &lhs, size_equal_only< T > const &rhs)
template<typename T >
bool | operator== (size_equal_only< T > const &lhs, size_equal_only< T > const &rhs)

## Typedef Documentation

## fix_int16

typedef fix_int<int16_t> msgpack::type::fix_int16

## fix_int32

typedef fix_int<int32_t> msgpack::type::fix_int32

## fix_int64

typedef fix_int<int64_t> msgpack::type::fix_int64

## fix_int8

typedef fix_int<int8_t> msgpack::type::fix_int8

## fix_uint16

typedef fix_int<uint16_t> msgpack::type::fix_uint16

## fix_uint32

typedef fix_int<uint32_t> msgpack::type::fix_uint32

## fix_uint64

typedef fix_int<uint64_t> msgpack::type::fix_uint64

## fix_uint8

typedef fix_int<uint8_t> msgpack::type::fix_uint8

## nil

typedef nil_t msgpack::type::nil

## Enumeration Type Documentation

## object_type

enum msgpack::type::object_type

Enumerator
NIL |
BOOLEAN |
POSITIVE_INTEGER |
NEGATIVE_INTEGER |
FLOAT32 |
FLOAT64 |
FLOAT |
STR |
BIN |
ARRAY |
MAP |
EXT |

## Function Documentation

## convert_helper() [1/2]

template<typename T >

std::enable_if< has_as<T>::value>::type msgpack::type::convert_helper | ( | msgpack::object const & | o,
|  | T & | t
| ) |  |

inline

References msgpack::object::as().

Referenced by msgpack::type::define_array_imp< Tuple, N >::unpack(), msgpack::type::define_map_imp< Tuple, N >::unpack(), and msgpack::type::define_array_imp< Tuple, 1 >::unpack().

## convert_helper() [2/2]

template<typename T >

std::enable_if< !has_as<T>::value>::type msgpack::type::convert_helper | ( | msgpack::object const & | o,
|  | T & | t
| ) |  |

inline

References msgpack::object::convert().

## forward_as_tuple()

template<class... Args>

tuple< Args &&... > msgpack::type::forward_as_tuple | ( | Args &&... | args | ) |

inline noexcept

Referenced by msgpack::type::tuple< Types >::size().

## make_array_ref() [1/4]

template<typename T >

msgpack::enable_if< !msgpack::is_array<T const>::value, array_ref<T const>>::type msgpack::type::make_array_ref | ( | const T & | t | ) |

inline

## make_array_ref() [2/4]

template<typename T >

msgpack::enable_if< !msgpack::is_array<T>::value, array_ref<T>>::type msgpack::type::make_array_ref | ( | T & | t | ) |

inline

## make_array_ref() [3/4]

template<typename T , std::size_t N>

array_ref< const T[N]> msgpack::type::make_array_ref | ( | const T(&) | t[N] | ) |

inline

## make_array_ref() [4/4]

template<typename T , std::size_t N>

array_ref< T[N]> msgpack::type::make_array_ref | ( | T(&) | t[N] | ) |

inline

## make_define_array() [1/2]

template<typename... Args>

define_array< Args... > msgpack::type::make_define_array | ( | Args &... | args | ) |

inline

## make_define_array() [2/2]

define_array msgpack::type::make_define_array | ( |  | ) |

inline

Referenced by msgpack::type::define_array<>::msgpack_object().

## make_define_map() [1/2]

template<typename... Args>

define_map< Args... > msgpack::type::make_define_map | ( | Args &... | args | ) |

inline

## make_define_map() [2/2]

define_map msgpack::type::make_define_map | ( |  | ) |

inline

## make_size_equal_only()

template<typename T >

size_equal_only< T > msgpack::type::make_size_equal_only | ( | T & | t | ) |

inline

## make_tuple() [1/2]

template<class... Args>

tuple< Args... > msgpack::type::make_tuple | ( | Args &&... | args | ) |

inline

## make_tuple() [2/2]

tuple msgpack::type::make_tuple | ( |  | ) |

inline

Referenced by msgpack::StdTupleAsImpl< T, Args >::as(), msgpack::MsgpackTupleAsImpl< T, Args >::as(), msgpack::type::tuple< Types >::size(), and msgpack::adaptor::as< T, typename msgpack::enable_if< detail::is_seq_no_pair_no_tuple< T >::value &&boost::mpl::fold< T, boost::mpl::bool_< true >, boost::mpl::if_< boost::mpl::or_< boost::mpl::_1, msgpack::has_as< boost::mpl::_2 > >, boost::mpl::bool_< true >, boost::mpl::bool_< false > > >::type::value >::type >::to_tuple().

## operator<() [1/2]

bool msgpack::type::operator< | ( | nil_t const & | lhs,
|  | nil_t const & | rhs
| ) |  |

inline

## operator<() [2/2]

template<typename T >

bool msgpack::type::operator< | ( | size_equal_only< T > const & | lhs,
|  | size_equal_only< T > const & | rhs
| ) |  |

inline

References msgpack::type::size_equal_only< T >::m_t.

## operator==() [1/2]

bool msgpack::type::operator== | ( | nil_t const & | lhs,
|  | nil_t const & | rhs
| ) |  |

inline

## operator==() [2/2]

template<typename T >

bool msgpack::type::operator== | ( | size_equal_only< T > const & | lhs,
|  | size_equal_only< T > const & | rhs
| ) |  |

inline

References msgpack::type::size_equal_only< T >::m_t.

## size() [1/3]

template<typename T >

std::size_t msgpack::type::size | ( | T const & | t | ) |

inline

Referenced by msgpack::detail::add_ext_type_size< 4 >(), msgpack::zone::allocate_no_align(), msgpack::unpacker::buffer_consumed(), msgpack::detail::check_container_size_for_ext< 4 >(), msgpack::detail::context< VisitorHolder >::check_ext_size(), msgpack::checked_get_container_size(), msgpack::clone(), msgpack::type::define_array<>::msgpack_object(), msgpack::zone::operator delete(), msgpack::zone::operator new(), msgpack::adaptor::pack< const char * >::operator()(), msgpack::adaptor::object_with_zone< const char * >::operator()(), msgpack::adaptor::pack< std::vector< bool, Alloc > >::operator()(), msgpack::adaptor::pack< std::string >::operator()(), msgpack::adaptor::pack< std::tuple< Args... > >::operator()(), msgpack::adaptor::object< const char * >::operator()(), msgpack::adaptor::pack< std::array< char, N > >::operator()(), msgpack::adaptor::pack< std::array< unsigned char, N > >::operator()(), msgpack::adaptor::object< std::string >::operator()(), msgpack::adaptor::pack< std::forward_list< T, Alloc > >::operator()(), msgpack::adaptor::pack< std::unordered_set< Key, Hash, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::vector< bool, Alloc > >::operator()(), msgpack::adaptor::pack< std::unordered_map< K, V, Hash, Compare, Alloc > >::operator()(), msgpack::adaptor::pack< std::list< T, Alloc > >::operator()(), msgpack::adaptor::pack< std::deque< T, Alloc > >::operator()(), msgpack::adaptor::pack< std::vector< unsigned char, Alloc > >::operator()(), msgpack::adaptor::object< std::array< char, N > >::operator()(), msgpack::adaptor::pack< std::set< T, Compare, Alloc > >::operator()(), msgpack::adaptor::object< std::array< unsigned char, N > >::operator()(), msgpack::adaptor::object_with_zone< std::string >::operator()(), msgpack::adaptor::pack< std::vector< char, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::forward_list< T, Alloc > >::operator()(), msgpack::adaptor::convert< type::size_equal_only< T > >::operator()(), msgpack::adaptor::pack< std::vector< T, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::unordered_set< Key, Hash, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::list< T, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::unordered_map< K, V, Hash, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::deque< T, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::array< char, N > >::operator()(), msgpack::adaptor::object_with_zone< std::array< unsigned char, N > >::operator()(), msgpack::adaptor::object< std::vector< char, Alloc > >::operator()(), msgpack::adaptor::object< std::vector< unsigned char, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::set< T, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::vector< T, Alloc > >::operator()(), msgpack::adaptor::pack< T[N]>::operator()(), msgpack::adaptor::pack< type::assoc_vector< K, V, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::vector< char, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::vector< unsigned char, Alloc > >::operator()(), msgpack::adaptor::pack< char[N]>::operator()(), msgpack::adaptor::object_with_zone< type::assoc_vector< K, V, Compare, Alloc > >::operator()(), msgpack::adaptor::pack< std::array< T, N > >::operator()(), msgpack::detail::unpack_array::operator()(), msgpack::adaptor::pack< const char[N]>::operator()(), msgpack::adaptor::object_with_zone< std::array< T, N > >::operator()(), msgpack::adaptor::pack< unsigned char[N]>::operator()(), msgpack::adaptor::convert< T, typename msgpack::enable_if< detail::is_seq_no_pair_no_tuple< T >::value >::type >::operator()(), msgpack::adaptor::pack< std::unordered_multiset< Key, Hash, Compare, Alloc > >::operator()(), msgpack::detail::unpack_map::operator()(), msgpack::adaptor::pack< std::unordered_multimap< K, V, Hash, Compare, Alloc > >::operator()(), msgpack::adaptor::pack< const unsigned char[N]>::operator()(), msgpack::adaptor::object_with_zone< std::unordered_multiset< Key, Hash, Compare, Alloc > >::operator()(), msgpack::adaptor::pack< std::multiset< T, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::unordered_multimap< K, V, Hash, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< T[N]>::operator()(), msgpack::adaptor::pack< T, typename msgpack::enable_if< detail::is_seq_no_pair_no_tuple< T >::value >::type >::operator()(), msgpack::adaptor::object_with_zone< std::tuple< Args... > >::operator()(), msgpack::adaptor::object_with_zone< std::multiset< T, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< char[N]>::operator()(), msgpack::adaptor::pack< std::map< K, V, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< T, typename msgpack::enable_if< detail::is_seq_no_pair_no_tuple< T >::value >::type >::operator()(), msgpack::adaptor::object_with_zone< const char[N]>::operator()(), msgpack::adaptor::object_with_zone< std::map< K, V, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< unsigned char[N]>::operator()(), msgpack::adaptor::object_with_zone< const unsigned char[N]>::operator()(), msgpack::adaptor::object< char[N]>::operator()(), msgpack::adaptor::object< const char[N]>::operator()(), msgpack::adaptor::pack< std::multimap< K, V, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::multimap< K, V, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< msgpack::object >::operator()(), msgpack::unpacker::reserve_buffer(), msgpack::type::tuple<>::size(), msgpack::unpacker::skip_nonparsed_buffer(), msgpack::detail::create_object_visitor::start_array(), msgpack::detail::create_object_visitor::start_map(), msgpack::zone::swap(), msgpack::type::define_array_imp< Tuple, N >::unpack(), msgpack::type::define_array_imp< Tuple, 1 >::unpack(), msgpack::detail::create_object_visitor::visit_bin(), msgpack::detail::create_object_visitor::visit_str(), and msgpack::object_stringize_visitor::visit_str().

## size() [2/3]

template<typename T , std::size_t N>

std::size_t msgpack::type::size | ( | const | T(&)[N] | ) |

inline

## size() [3/3]

template<typename... T>

std::size_t msgpack::type::size | ( | std::tuple< T... > const & |  | ) |

inline

## tie()

template<class... Args>

tuple< Args &... > msgpack::type::tie | ( | Args &... | args | ) |

inline

Referenced by msgpack::type::tuple< Types >::size().

## tuple_cat()

template<class... Tuples>

auto msgpack::type::tuple_cat | ( | Tuples &&... | args | ) | -> decltype(std::tuple_cat(std::forward< typename std::remove_reference< Tuples >::type::base >(args)...))

inline

Referenced by msgpack::StdTupleAsImpl< T, Args >::as(), msgpack::MsgpackTupleAsImpl< T, Args >::as(), and msgpack::type::tuple< Types >::size().